package net.sf.sql2java.fetching.sql.link;

import net.sf.sql2java.data.holders.Column;

public class ManyToManyLink implements DatabaseLink {
	private Column primaryOne;
	private Column primaryMany;
	private Column secondaryMany;
	private Column secondaryOne;
	
// -- Constructors ------------------------------------------------------------
	
	public ManyToManyLink() { }
	
	public ManyToManyLink(Column primaryOne, Column primaryMany,
			Column secondaryMany, Column secondaryOne) {
		this.primaryOne = primaryOne;
		this.primaryMany = primaryMany;
		this.secondaryMany = secondaryMany;
		this.secondaryOne = secondaryOne;
	}

// -- Conversion --------------------------------------------------------------
	
	@Override
	public String toString() {
		return String.format(
				"[%s] <-> [%s]", 
				primaryOne.getFullName(), 
				secondaryOne.getFullName()
		);
	}
	
// -- Getters -----------------------------------------------------------------
	
	public Column getPrimaryOne() {
		return primaryOne;
	}
	
	public Column getPrimaryMany() {
		return primaryMany;
	}
	
	public Column getSecondaryMany() {
		return secondaryMany;
	}
	
	public Column getSecondaryOne() {
		return secondaryOne;
	}
	
// -- Setters -----------------------------------------------------------------
	
	public void setPrimaryOne(Column primaryOne) {
		this.primaryOne = primaryOne;
	}
	
	public void setPrimaryMany(Column primaryMany) {
		this.primaryMany = primaryMany;
	}
	
	public void setSecondaryMany(Column secondaryMany) {
		this.secondaryMany = secondaryMany;
	}

	public void setSecondaryOne(Column secondaryOne) {
		this.secondaryOne = secondaryOne;
	}
}
