package net.sf.sql2java.generator.events;

import org.apache.velocity.app.event.ReferenceInsertionEventHandler;

public class CamelCaseStringReference implements ReferenceInsertionEventHandler {
	
// -- Constructors ------------------------------------------------------------
	
	public CamelCaseStringReference() {
	}
	
// -- Implementations ---------------------------------------------------------

	@Override
	public Object referenceInsert(String reference, Object value) {
		// -- return the value if it isn't a string
		if (! (value instanceof String)) return value;
		if (value.toString().indexOf('_') == -1) return value;

		// -- convert the value to a String
		String input = value.toString();
		
		StringBuffer result = new StringBuffer();
		boolean shouldCapitalize = false;
		
		for (int i = 0; i < input.length(); i++)
			if (input.charAt(i) == '_')
				shouldCapitalize = true;
			else
				if (shouldCapitalize) {
					result.append(input.substring(i, i + 1).toUpperCase());
					shouldCapitalize = false;
				} else result.append(input.subSequence(i, i + 1));
		
		// -- return the result
		return result.toString();
	}
	
}
