package net.sf.sql2java.generator.template;

import net.sf.sql2java.common.parameters.MomentumObject;
import net.sf.sql2java.common.resources.Resource;
import net.sf.sql2java.generator.template.pack.TemplatePack;

/**
 *
 * @author daang
 */
public class Template extends MomentumObject {
	public static final String PROPERTY_RESOURCE 	= "resource";
	public static final String PROPERTY_CONTENT 	= "content";
	public static final String PROPERTY_PATH	 	= "path";
	public static final String PROPERTY_ENTITY_NAME = "entityName";
	
    private String name;
    private String scope;
    private String extension;

    private TemplatePack templatePack;
    
// -- Constructors ------------------------------------------------------------
    
    public Template() {
        this("", "", "unknown");
    }
    
    public Template(String name, String resource, String scope) {
    	super("template");
    	
        this.name = name;
        this.scope = scope;
        
        setResource(resource);
    }
    
// -- Getters -----------------------------------------------------------------
    
    public String getName() {
        return name;
    }

    public String getResource() {
    	return getProperty(PROPERTY_RESOURCE);
    }

    public String getScope() {
        return scope;
    }
    
    public String getContent() {
    	return getProperty(PROPERTY_CONTENT);
    }
    
    public TemplatePack getTemplatePack() {
        return templatePack;
    }
    
    public String getPath() {
    	return getProperty(PROPERTY_PATH);
	}
    
    public String getEntityName() {
    	return getProperty(PROPERTY_ENTITY_NAME);
    }
    
    public String getExtension() {
        return extension;
    }
    
    public String getFilename() {
        return getEntityName() + extension;
    }
    
    public String getFullPath() {
    	// -- create the resource
    	Resource resource = new Resource();
    	
    	resource.append(getTemplatePack().getPath());
    	resource.append(getPath());
    	
    	// -- return the result
    	return resource.getPath();
    }
    
// -- Setters -----------------------------------------------------------------

    public void setName(String name) {
        this.name = name;
    }
    
    public void setResource(String resource) {
    	setProperty(PROPERTY_RESOURCE, resource);
    }

    public void setScope(String scope) {
        this.scope = scope;
    }

    public void setContent(String content) {
    	setProperty(PROPERTY_CONTENT, content);
    }
    
    public void setTemplatePack(TemplatePack templatePack) {
        this.templatePack = templatePack;
    }
    
    public void setPath(String path) {
    	setProperty(PROPERTY_PATH, path);
	}

    public void setEntityName(String entityName) {
    	setProperty(PROPERTY_ENTITY_NAME, entityName);
    }

    public void setExtension(String extension) {
        this.extension = extension;
    }
}
